﻿class FahrenheitToCelsius:
    def __init__(self, value):
        self.temperature = value    #Property is initialized. This calls the setter

    #Use the decorator @property to define the getter
    @property
    def temperature(self):
        return 5.0 / 9 * (self._temperature - 32)

    #Use the decorator @field_name.setter to define the setter
    @temperature.setter
    def temperature(self, value):
        if value >= -459.67: 
            self._temperature = value
        else:
            raise ValueError("There is no temperature below -459.67")    

#Main code starts here
x = FahrenheitToCelsius(-50)  #Create object x. This calls the constructor which,
                              #in turn, calls the setter.

print(x.temperature)          #This calls the getter.

x.temperature = -65           #This calls the setter.
print(x.temperature)          #This calls the getter.

x.temperature = -500          #This calls the setter and throws an error
print(x.temperature)
